SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[reg_cat_dimension]') AND type in (N'P', N'PC'))DROP PROCEDURE [dbo].[reg_cat_dimension]
GO
CREATE PROCEDURE [reg_cat_dimension]
	@p_id INT
AS
BEGIN
	SELECT 	[id] AS [id],
		[uid] AS [uid],
		[eid] AS [eid],
		[id_usuario_modifico] AS [id_usuario_modifico],
		[id_usuario_creo] AS [id_usuario_creo],
		[fechaModificacion] AS [fechaModificacion],
		[fechaCreacion] AS [fechaCreacion],
		[active] AS [active],
		[dimension] AS [dimension],
		[dimension_codigo] AS [dimension_codigo],
		[aplicaEnX] AS [aplicaEnX],
		[aplicaEnY] AS [aplicaEnY],
		[aplicaEnZ] AS [aplicaEnZ]
	FROM [cat_dimension]
	WHERE	(id = @p_id)

END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON
GO
----------------------
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON
GO
IF  EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[dbo].[view_cat_dimension]')) DROP VIEW [dbo].[view_cat_dimension]
GO
CREATE  VIEW [view_cat_dimension] AS
SELECT 	[cat_dimension].[id] AS [id],
		[cat_dimension].[uid] AS [uid],
		[cat_dimension].[eid] AS [eid],
		[cat_dimension].[id_usuario_modifico] AS [id_usuario_modifico],
		[cat_dimension].[id_usuario_creo] AS [id_usuario_creo],
		[cat_dimension].[fechaModificacion] AS [fechaModificacion],
		[cat_dimension].[fechaCreacion] AS [fechaCreacion],
		[cat_dimension].[active] AS [active],
		[cat_dimension].[dimension] AS [dimension],
		[cat_dimension].[dimension_codigo] AS [dimension_codigo],
		[cat_dimension].[aplicaEnX] AS [aplicaEnX],
		[cat_dimension].[aplicaEnY] AS [aplicaEnY],
		[cat_dimension].[aplicaEnZ] AS [aplicaEnZ],
		[empresaCodigo].[empresa] As [multiempresa]
FROM [cat_dimension]
	INNER JOIN [seg_usuario] AS [seg_usuario_modifico] ON [seg_usuario_modifico].id=[cat_dimension].[id_usuario_modifico]
	INNER JOIN [seg_usuario] AS [seg_usuario_creo] ON [seg_usuario_creo].id=[cat_dimension].[id_usuario_creo]
	INNER JOIN [gen_empresa] AS empresaCodigo ON [cat_dimension].eid = [empresaCodigo].[codigo] and empresaCodigo.active=1
WHERE [cat_dimension].active=1
GO
SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sel_cat_dimensionesXusuario_modifico]') AND type in (N'P', N'PC'))DROP PROCEDURE [dbo].[sel_cat_dimensionesXusuario_modifico]
GO
CREATE PROCEDURE [sel_cat_dimensionesXusuario_modifico]
	@p_id_usuario_modifico INT
AS
BEGIN
	SELECT * 
	FROM [view_cat_dimension]
	WHERE ([id_usuario_modifico]= @p_id_usuario_modifico)
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON
GO
----------------------
SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sel_cat_dimensionesXusuario_creo]') AND type in (N'P', N'PC'))DROP PROCEDURE [dbo].[sel_cat_dimensionesXusuario_creo]
GO
CREATE PROCEDURE [sel_cat_dimensionesXusuario_creo]
	@p_id_usuario_creo INT
AS
BEGIN
	SELECT * 
	FROM [view_cat_dimension]
	WHERE ([id_usuario_creo]= @p_id_usuario_creo)
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON
GO
----------------------
SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sel_cat_dimensiones]') AND type in (N'P', N'PC'))DROP PROCEDURE [dbo].[sel_cat_dimensiones]
GO
CREATE PROCEDURE [sel_cat_dimensiones]
	
	@p_filtro as varchar (8000) = '1=1',
	@p_orden as varchar (8000) = 'id',
	@p_campos as varchar (8000) = '*' AS
BEGIN
exec ('SELECT '+ @p_campos +
' FROM [view_cat_dimension]
WHERE (' + @p_filtro + ') ORDER BY ' + @p_orden)
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON
GO
----------------------

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[lis_cat_dimensiones]') AND type in (N'P', N'PC'))DROP PROCEDURE [dbo].[lis_cat_dimensiones]
GO
CREATE PROCEDURE [lis_cat_dimensiones]
	AS
BEGIN
	SELECT id AS id,
[dimension] AS [cat_dimension]
	FROM [cat_dimension]
	WHERE active = 1
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON
GO
----------------------
SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[upd_cat_dimension]') AND type in (N'P', N'PC'))DROP PROCEDURE [dbo].[upd_cat_dimension]
GO
CREATE PROCEDURE [upd_cat_dimension]
	@p_id int = null,
		@p_uid varchar(500) = null,
		@p_eid varchar(50) = null,
		@p_id_usuario_modifico int = null,
		@p_id_usuario_creo int = null,
		@p_fechaCreacion smalldatetime = null,
		@p_dimension varchar(300) = null,
		@p_dimension_codigo varchar(100) = null,
		@p_aplicaEnX bit = null,
		@p_aplicaEnY bit = null,
		@p_aplicaEnZ bit = null
AS
BEGIN
		UPDATE [cat_dimension]
		SET	[uid] = isnull(@p_uid,[uid]),
			[eid] = isnull(@p_eid,[eid]),
			[id_usuario_modifico] = isnull(@p_id_usuario_modifico,[id_usuario_modifico]),
			[id_usuario_creo] = isnull(@p_id_usuario_creo,[id_usuario_creo]),
			[fechaModificacion] = GETDATE(),
			[dimension] = isnull(@p_dimension,[dimension]),
			[dimension_codigo] = isnull(@p_dimension_codigo,[dimension_codigo]),
			[aplicaEnX] = isnull(@p_aplicaEnX,[aplicaEnX]),
			[aplicaEnY] = isnull(@p_aplicaEnY,[aplicaEnY]),
			[aplicaEnZ] = isnull(@p_aplicaEnZ,[aplicaEnZ])
		WHERE (id = @p_id)
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON
GO
----------------------
SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ins_cat_dimension]') AND type in (N'P', N'PC'))DROP PROCEDURE [dbo].[ins_cat_dimension]
GO
CREATE PROCEDURE [ins_cat_dimension]
	@p_uid varchar(500),
		@p_eid varchar(50),
		@p_id_usuario_modifico int,
		@p_id_usuario_creo int,
		@p_dimension varchar(300),
		@p_dimension_codigo varchar(100),
		@p_aplicaEnX bit,
		@p_aplicaEnY bit,
		@p_aplicaEnZ bit
AS
BEGIN
	DECLARE @v_id int
		INSERT INTO [cat_dimension]
			([uid],
			[eid],
			[id_usuario_modifico],
			[id_usuario_creo],
			[fechaModificacion],
			[fechaCreacion],
			[dimension],
			[dimension_codigo],
			[aplicaEnX],
			[aplicaEnY],
			[aplicaEnZ])
		VALUES(	@p_uid,
			@p_eid,
			@p_id_usuario_modifico,
			@p_id_usuario_creo,
			GETDATE(),
			GETDATE(),
			@p_dimension,
			@p_dimension_codigo,
			@p_aplicaEnX,
			@p_aplicaEnY,
			@p_aplicaEnZ)
		SET @v_id = scope_identity()
UPDATE [cat_dimension] set [uid] = [uid] + '_' + convert(varchar(20),@v_id) where [id]=@v_id
SELECT @v_id as id
RETURN @v_id
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON
GO
----------------------
SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[act_cat_dimension]') AND type in (N'P', N'PC'))DROP PROCEDURE [dbo].[act_cat_dimension]
GO
CREATE PROCEDURE [act_cat_dimension]
	@p_active BIT,
	@p_id INT,
@p_id_usuario_modifico int = null
AS
BEGIN
	UPDATE [cat_dimension]
	SET active=@p_active,
	[id_usuario_modifico] = isnull(@p_id_usuario_modifico,[id_usuario_modifico]),
	[fechaModificacion] = GETDATE()
	WHERE	(id = @p_id)
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON
GO
----------------------

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[reg_cat_dimension_m]') AND type in (N'P', N'PC'))DROP PROCEDURE [dbo].[reg_cat_dimension_m]
GO
CREATE PROCEDURE [reg_cat_dimension_m]
	@p_id INT,
	@p_eid as varchar(50) = ''
AS
BEGIN
	SELECT 	[id] AS [id],
		[uid] AS [uid],
		[eid] AS [eid],
		[id_usuario_modifico] AS [id_usuario_modifico],
		[id_usuario_creo] AS [id_usuario_creo],
		[fechaModificacion] AS [fechaModificacion],
		[fechaCreacion] AS [fechaCreacion],
		[active] AS [active],
		[dimension] AS [dimension],
		[dimension_codigo] AS [dimension_codigo],
		[aplicaEnX] AS [aplicaEnX],
		[aplicaEnY] AS [aplicaEnY],
		[aplicaEnZ] AS [aplicaEnZ]
	FROM [cat_dimension]
	WHERE	(id = @p_id)
	AND	(eid LIKE @p_eid+'%')

END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON
GO
----------------------
SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sel_cat_dimensionesXusuario_modifico_m]') AND type in (N'P', N'PC'))DROP PROCEDURE [dbo].[sel_cat_dimensionesXusuario_modifico_m]
GO
CREATE PROCEDURE [sel_cat_dimensionesXusuario_modifico_m]
	@p_id_usuario_modifico INT,
	@p_eid as varchar(50) = ''
AS
BEGIN
	SELECT *
	FROM [view_cat_dimension]
	WHERE ([id_usuario_modifico]= @p_id_usuario_modifico)
	AND	(eid LIKE @p_eid+'%')
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON
GO
----------------------
SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sel_cat_dimensionesXusuario_creo_m]') AND type in (N'P', N'PC'))DROP PROCEDURE [dbo].[sel_cat_dimensionesXusuario_creo_m]
GO
CREATE PROCEDURE [sel_cat_dimensionesXusuario_creo_m]
	@p_id_usuario_creo INT,
	@p_eid as varchar(50) = ''
AS
BEGIN
	SELECT *
	FROM [view_cat_dimension]
	WHERE ([id_usuario_creo]= @p_id_usuario_creo)
	AND	(eid LIKE @p_eid+'%')
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON
GO
----------------------
SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sel_cat_dimensiones_m]') AND type in (N'P', N'PC'))DROP PROCEDURE [dbo].[sel_cat_dimensiones_m]
GO
CREATE PROCEDURE [sel_cat_dimensiones_m]
	@p_eid as varchar (50)='',
	@p_filtro as varchar (8000) = '1=1',
	@p_orden as varchar (8000) = 'id',
	@p_campos as varchar (8000) = '*' AS
BEGIN
exec ('SELECT '+ @p_campos +
' FROM [view_cat_dimension]
WHERE  (eid like '''+@p_eid+'%'+''' ) AND (' + @p_filtro + ') ORDER BY ' + @p_orden)
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON
GO
----------------------

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[lis_cat_dimensiones_m]') AND type in (N'P', N'PC'))DROP PROCEDURE [dbo].[lis_cat_dimensiones_m]
GO
CREATE PROCEDURE [lis_cat_dimensiones_m]
	@p_eid as varchar(50) = ''
AS
BEGIN
	SELECT id AS id,
[dimension] AS [cat_dimension]
	FROM [cat_dimension]
	WHERE active = 1
	AND	(eid LIKE @p_eid+'%')
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON
GO
----------------------

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[aud_cat_dimension]') AND type in (N'P', N'PC'))DROP PROCEDURE [dbo].[aud_cat_dimension]
GO
CREATE PROCEDURE [aud_cat_dimension]
	@p_filtro as varchar (8000) = '1=1'
AS
BEGIN
exec(	'SELECT [cat_dimension].id as id_tabla,
	[cat_dimension].id_usuario_modifico as id_usuario_modifico,
	[cat_dimension].id_usuario_creo as id_usuario_creo,
	[cat_dimension].fechaModificacion as fechaModificacion,
	[cat_dimension].fechaCreacion as fechaCreacion,
	[cat_dimension].active as active,
	[cat_dimension].[dimension] as campoPrincipal,
	[seg_usuario_creo].usuario as usuarioCreo,
	[seg_usuario_modifico].usuario as usuarioModifico

	FROM [cat_dimension]
	INNER JOIN [seg_usuario] AS [seg_usuario_modifico] ON [seg_usuario_modifico].id=[cat_dimension].[id_usuario_modifico]
	INNER JOIN [seg_usuario] AS [seg_usuario_creo] ON [seg_usuario_creo].id=[cat_dimension].[id_usuario_creo]
	where ' + @p_filtro)
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON
GO
----------------------
print 'cat_dimension'
-----------------------------------01/08/2012 11:34:27 a.m.